<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, computed, type Ref, inject } from 'vue';
import ApexChart from "vue3-apexcharts";
import { useI18n } from 'vue-i18n';
import { request } from '@/lib/request';
import SparkChart from "@/components/statistics/SparkChart.vue";
import Login from "@/components/statistics/Login.vue";
import Button from "@/components/general/Button.vue";


const { t } = useI18n();
const $t = t;
document.title = $t('dashboard.label');
let configuration = inject<any>('configuration');

type pane = {
    count_panes: number,
    users: number,
    institutions: number,
    max_user_day: number,
    max_user_overall: number
}

type data = {
    cpu: number,
    heap: number,
    memory: number,
    pane_count: number,
    requests_per_second?: number
    response_time?: number
    timestamp: string
    user_count: number
}

type os = {
    freemem: number,
    totalmem: number,
    storage: { available: number, used: number }
}

type statistics = {
    pane: pane,
    data: data[],
    os: os
}

const stats: Ref<statistics | null> = ref(null);
const date = ref(new Date().toISOString().substring(0, 10));
const cpuData: any = ref([]);
const userData: any = ref([]);
const paneData: any = ref([]);
const memoryData: any = ref([]);
const heapData: any = ref([]);

const cpuDataSpark: any = ref([]);
const userDataSpark: any = ref([]);
const paneDataSpark: any = ref([]);
const memoryDataSpark: any = ref([]);
const heapDataSpark: any = ref([]);

const sparkChartCPUTitle = ref('');
const sparkChartHeapTitle = ref('');
const sparkChartUserTitle = ref('');
const sparkChartPaneTitle = ref('');

const getDate = computed(() => {
    return new Date(date.value).toLocaleDateString();
});

const getRESTData = async () => {
    try {
        let response = await request('GET', configuration.apiServer + '/api/stats');
        if (response)
            stats.value = response;
        prepareData();
    } catch (error) {
        console.error(error);
    }
};

getRESTData();

const getDateForChart = (direction: string) => {
    if (direction === "-") {
        let dateObj = new Date(date.value);
        dateObj.setDate(dateObj.getDate() - 1)
        date.value = dateObj.toISOString().substring(0, 10);
    } else if (direction === "+") {
        let dateObj = new Date(date.value);
        dateObj.setDate(dateObj.getDate() + 1)
        date.value = dateObj.toISOString().substring(0, 10);
    } else {
        date.value = new Date().toISOString().substr(0, 10);
    }
    getRESTDataReturn();
};

const getRESTDataReturn = async () => {
    try {
        let response = await request('GET', configuration.apiServer + '/api/stats/' + date.value);
        if (response) {
            stats.value = response;
            prepareData();
        }
    } catch (error) {
        console.error(error);
    }
};

const prepareData = () => {
    if (stats.value !== null && stats.value.data.length > 0) {
        let cpu = [];
        let user = [];
        let pane = [];
        let memory = [];
        let heap = [];
        let i = 0;
        while (i < stats.value.data.length) {
            let x = stats.value.data[i];
            let time = x.timestamp;
            let userArr = [[time], [x.user_count]];
            let paneArr = [[time], [x.pane_count]];
            let cpuArr = [[time], [Math.round(x.cpu * 100) / 100]];
            let memoryArr = [[time], [Math.round(x.memory)]];
            let heapArr = [[time], [Math.round(x.heap)]];
            user.push(userArr);
            pane.push(paneArr);
            cpu.push(cpuArr);
            memory.push(memoryArr);
            heap.push(heapArr);
            i = i + 10;
        }
        if (new Date().toDateString() === new Date(date.value).toDateString()) {
            cpuDataSpark.value = cpu;
            userDataSpark.value = user;
            paneDataSpark.value = pane;
            memoryDataSpark.value = memory;
            heapDataSpark.value = heap;
            let length = stats.value.data.length - 1;
            sparkChartCPUTitle.value = stats.value.data[length].cpu + " %";
            sparkChartHeapTitle.value = stats.value.data[length].heap + " MB";
            sparkChartPaneTitle.value = String(stats.value.data[length].pane_count);
            sparkChartUserTitle.value = String(stats.value.data[length].user_count);
        }
        cpuData.value = cpu;
        userData.value = user;
        paneData.value = pane;
        memoryData.value = memory;
        heapData.value = heap;
    }
};


const getTotalPaneCount = computed(() => {
    if (stats.value !== null && stats.value.pane !== null && stats.value.pane.count_panes !== null) {
        return Math.round(stats.value.pane.count_panes);
    }
    else
        return 0;
});

const getTotalUserCount = computed(() => {
    if (stats.value !== null && stats.value.pane !== null && stats.value.pane.users !== null) {
        return Math.round(stats.value.pane.users);
    }
    else
        return 0;
});

const getTotalInstitutionsCount = computed(() => {
    if (stats.value !== null && stats.value.pane !== null && stats.value.pane.institutions !== null) {
        return Math.round(stats.value.pane.institutions);
    }
    else
        return 0;
});

const getMaxCPUPeak = computed(() => {
    if (stats.value !== null && stats.value.data) {
        let cpu = stats.value.data.map((x) => { return Number(x.cpu) });
        return Math.max(...cpu);
    }
    else
        return null;
});

const getMaxRAMPeak = computed(() => {
    if (stats.value !== null && stats.value.data) {
        let memory = stats.value.data.map((x) => { return Number(x.memory) });
        return Math.max(...memory);
    }
    else
        return null;
});

const getMaxUserDay = computed(() => {
    if (stats.value !== null && stats.value.pane !== null && stats.value.pane.max_user_day !== null) {
        return Math.round(stats.value.pane.max_user_day);
    }
    else
        return 0;
});

const getMaxUserOverall = computed(() => {
    if (stats.value !== null && stats.value.pane !== null && stats.value.pane.max_user_overall !== null) {
        return Math.round(stats.value.pane.max_user_overall);
    }
    else
        return 0;
});

const gaugeOptions = computed(() => {
    return {
        chart: {
            id: "memory"
        },
        labels: [$t("statisticPage.diagrams.ram.usage.app"), $t("statisticPage.diagrams.ram.usage.system"), $t("statisticPage.diagrams.ram.usage.free")],
        legend: {
            show: false,
            position: 'top'
        },
        /*responsive: [
        {
            breakpoint: 480,
            options: {
                chart: {
                    width: 200
                },
                legend: {
                    position: 'bottom'
                }
            }
        }],*/
        title: {
            text: $t("statisticPage.diagrams.ram.usage.header"),
            offsetX: 10,
            offsetY: 10,
            style: {
                fontSize: '24px',
                cssClass: 'text-xl'
            }
        }
    }
});

const getLastMemory = computed(() => {
    if (stats.value !== null && stats.value.data && stats.value.data.length > 0) {
        let length = stats.value.data.length - 1;
        return Math.round(stats.value.data[length].memory);
    }
    else
        return 0;
});

const getSystemTotalMemory = computed(() => {
    if (stats.value !== null && stats.value.os !== null) {
        return Math.round(stats.value.os.totalmem);
    }
    else
        return 0;
});

const getSystemFreeMemory = computed(() => {
    if (stats.value !== null && stats.value.os !== null) {
        return Math.round(stats.value.os.freemem);
    }
    else
        return 0;
});

const gaugeSeries = computed(() => {
    return [getLastMemory.value, Number(getSystemTotalMemory.value) - Number(getSystemFreeMemory.value), getSystemFreeMemory.value]
});

const diskOptions = computed(() => {
    return {
        chart: {
            id: "storage"
        },
        labels: [$t("statisticPage.diagrams.storage.usedSpace"), $t("statisticPage.diagrams.storage.freeSpace")],
        legend: {
            show: false,
            position: 'top'
        },
        /*responsive: [
        {
            breakpoint: 480,
            options: {
                chart: {
                    width: 200
                },
                legend: {
                    position: 'bottom'
                }
            }
        }],*/
        title: {
            text: $t("statisticPage.diagrams.storage.usage"),
            offsetX: 10,
            offsetY: 10,
            style: {
                fontSize: '24px',
                cssClass: 'text-xl'
            }
        }
    }
});

const getSystemUsedStorage = computed(() => {
    if (stats.value !== null && stats.value.os !== null && stats.value.os.storage !== null) {
        return Math.round(stats.value.os.storage.used);
    }
    else
        return 0;
});

const getSystemAvailableStorage = computed(() => {
    if (stats.value !== null && stats.value.os !== null && stats.value.os.storage !== null) {
        return Math.round(stats.value.os.storage.available);
    }
    else
        return 0;
});

const diskSeries = computed(() => {
    return [getSystemUsedStorage.value, getSystemAvailableStorage.value];
});

const sparklineCPUSeries = computed(() => {
    return [{
        name: $t("statisticPage.diagrams.cpu.unit"),
        data: cpuDataSpark.value.filter(function (value: any, index: number, Arr: any) {
            return index % 3 == 0;
        }),
    }];
});

const sparklineHeapSeries = computed(() => {
    return [{
        name: $t("statisticPage.diagrams.heap.unit"),
        data: heapDataSpark.value.filter(function (value: any, index: number, Arr: any) {
            return index % 3 == 0;
        }),
    }];
});

const sparklinePaneSeries = computed(() => {
    return [{
        name: $t("statisticPage.diagrams.pane"),
        data: paneDataSpark.value.filter(function (value: any, index: number, Arr: any) {
            return index % 3 == 0;
        }),
    }];
});

const sparklineUserSeries = computed(() => {
    return [{
        name: $t("statisticPage.diagrams.user"),
        data: userDataSpark.value.filter(function (value: any, index: number, Arr: any) {
            return index % 3 == 0;
        }),
    }];
});

const chartOptions = computed(() => {
    return {
        series: [],
        chart: {
            height: 350,
            type: 'line',
            stacked: false,
            toolbar: {
                tools: {
                    download: false,
                    selection: true,
                    zoom: true,
                    zoomin: true,
                    zoomout: true,
                    pan: false,
                    reset: true
                }
            },
        },
        dataLabels: {
            enabled: false
        },
        stroke: {
            width: [1, 1, 4, 4]
        },
        xaxis: {
            //categories: time,
            type: 'datetime',
            //tickAmount: 15,
            labels: {
                formatter: function (value: any, timestamp: string) {
                    return new Date(timestamp).toTimeString().substring(0, 5)
                },
            }
        },
        yaxis: [
            {
                axisTicks: {
                    show: true,
                },
                axisBorder: {
                    show: true,
                    color: '#008FFB'
                },
                labels: {
                    formatter: function (val: any) {
                        if (val == undefined)
                            return val
                        return Number(val).toFixed(0);
                    },
                    style: {
                        colors: '#008FFB',
                    }
                },
                title: {
                    text: "Nutzer",
                    style: {
                        color: '#008FFB',
                    }
                },
                tooltip: {
                    enabled: true
                }
            },
            {
                seriesName: 'pane',
                opposite: false,
                axisTicks: {
                    show: true,
                },
                axisBorder: {
                    show: true,
                    color: '#00E396'
                },
                labels: {
                    formatter: function (val: any) {
                        if (val == undefined)
                            return val
                        return val.toFixed(0);
                    },
                    style: {
                        colors: '#00E396',
                    }
                },
                title: {
                    text: $t('statisticPage.diagrams.pane'),
                    style: {
                        color: '#00E396',
                    }
                },
            },
            {
                seriesName: $t("statisticPage.diagrams.cpu.usage"),
                opposite: true,
                axisTicks: {
                    show: true,
                },
                axisBorder: {
                    show: true,
                    color: '#FEB019'
                },
                labels: {
                    style: {
                        colors: '#FEB019',
                    },
                },
                title: {
                    text: $t('statisticPage.diagrams.cpu.unit'),
                    style: {
                        color: '#FEB019',
                    }
                }
            },
            {
                seriesName: 'memory',
                opposite: true,
                axisTicks: {
                    show: true,
                },
                axisBorder: {
                    show: true,
                    color: 'red'
                },
                labels: {
                    formatter: function (val: any) {
                        if (val == undefined)
                            return val
                        return val.toFixed(0);
                    },
                    style: {
                        colors: 'red',
                    },
                },
                title: {
                    text: $t('statisticPage.diagrams.ram.unit'),
                    style: {
                        color: 'red',
                    }
                }
            },
        ],
        tooltip: {
            x: {
                format: "hh:mm"
            },
        },
        title: {
            text: getDate.value,
            offsetX: 10,
            offsetY: 10,
            style: {
                fontSize: '24px',
                cssClass: 'text-xl'
            }
        },
        legend: {
            horizontalAlign: 'center',
            offsetY: -10,
            position: 'top',
            onItemClick: {
                toggleDataSeries: true
            },
            onItemHover: {
                highlightDataSeries: true
            },
        },
        noData: {
            text: $t('statisticPage.diagrams.error.noData')
        },
        grid: {
            padding: {
                bottom: 30
            }
        }
    };
});

const chartSeries = computed(() => {
    return [
        {
            name: $t("statisticPage.diagrams.user"),
            type: 'column',
            data: userData.value
        }, {
            name: $t("statisticPage.diagrams.pane"),
            type: 'column',
            data: paneData.value
        }, {
            name: $t("statisticPage.diagrams.cpu.unit"),
            type: 'line',
            data: cpuData.value
        }, {
            name: $t("statisticPage.diagrams.ram.unit"),
            type: 'line',
            data: memoryData.value
        }
    ];
});

const isLoginVisible = ref(true);
const showLogin = (value: boolean) => {
    isLoginVisible.value = value;
}

</script>
<template>
    <Login v-if="isLoginVisible" @hide="showLogin(false)" />
    <div class="bg-gray-100" v-else>
        <div class="flow-root box-content p-10 mx-auto">
            <div class="flex flex-col gap-4">
                <div class="flex flex-row w-full gap-4 items-stretch">
                    <div class="grow"></div>
                    <div class="w-2/5">
                        <div class="relative box-border transition duration-100 ease-in-out rounded-lg bg-white shadow-md"
                            id="gauge">
                            <ApexChart type="donut" :options="gaugeOptions" :series="gaugeSeries" v-if="gaugeSeries" />
                        </div>
                    </div>
                    <div class="w-2/5">
                        <div class="relative box-border transition duration-100 ease-in-out rounded-lg bg-white shadow-md"
                            id="hddUsage">
                            <ApexChart type="donut" :options="diskOptions" :series="diskSeries" v-if="diskSeries" />
                        </div>
                    </div>
                    <div class="grow"></div>
                </div>
                <div class="w-full flex flex-col gap-4">
                    <div class="relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md"
                        :key="date">
                        <div class="p-4">
                            <div id="chart">
                                <ApexChart type="line" :options="chartOptions" height="330px" :series="chartSeries" />
                            </div>
                            <div class="w-full flex flex-row">
                                <div class="flex flex-row gap-1 mx-auto">
                                    <div class="w-fit">
                                        <Button variant="cancel" @click="getDateForChart('-')"><i
                                                class="ri-history-line"></i></Button>
                                    </div>
                                    <div class="w-fit">
                                        <Button variant="white" @click="getDateForChart('today')">{{
                                            $t("statisticPage.buttons.today") }} <i class="ri-time-line"></i></Button>
                                    </div>
                                    <div class="w-fit">
                                        <Button variant="confirm" @click="getDateForChart('+')"><i
                                                class="ri-history-line scale-x-[-1]"></i></Button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="flex md:flex-row gap-2">
                        <div class="w-full">
                            <SparkChart :title="sparkChartCPUTitle" :subtitle="$t('statisticPage.diagrams.cpu.usage')"
                                :series="sparklineCPUSeries" />
                        </div>
                        <div class="w-full">
                            <SparkChart :title="sparkChartHeapTitle" :subtitle="$t('statisticPage.diagrams.heap.usage')"
                                :series="sparklineHeapSeries" />
                        </div>
                        <div class="w-full">
                            <SparkChart :title="sparkChartUserTitle" :subtitle="$t('statisticPage.diagrams.user')"
                                :series="sparklineUserSeries" />
                        </div>
                        <div class="w-full">
                            <SparkChart :title="sparkChartPaneTitle" :subtitle="$t('statisticPage.diagrams.pane')"
                                :series="sparklinePaneSeries" />
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md p-4 mt-4 flex flex-col gap-2">
                <h5 class="text-xl">{{ $t("statisticPage.texts.header") }}</h5>
                <div><span>{{ $t("statisticPage.texts.general.init") }}</span>
                    <strong class="text-2xl text-gray-700 mr-1">{{ getTotalPaneCount
                        }}</strong>
                    <span>{{ $t("statisticPage.texts.general.panes") }}</span>
                    <strong class="text-2xl text-gray-700 mr-1">{{ getTotalUserCount
                        }}</strong>
                    <span>{{ $t("statisticPage.texts.general.users") }}</span>
                    <strong class="text-2xl text-gray-700 mr-1">{{
                        getTotalInstitutionsCount }}</strong>
                    <span>{{ $t("statisticPage.texts.general.schools") }}</span>
                </div>
                <div>{{ $t("statisticPage.texts.today.init") }}
                    <strong class="text-2xl text-gray-700 mr-1">{{ getMaxCPUPeak
                        }}</strong>
                    <span>{{ $t("statisticPage.texts.today.cpu") }} </span>
                    <strong class="text-2xl text-gray-700 mr-1">{{ getMaxRAMPeak
                        }}</strong>
                    <span>{{ $t("statisticPage.texts.today.ram") }}</span>
                </div>
                <div>{{ $t("statisticPage.texts.total.init") }}
                    <strong class="text-2xl text-gray-700 mr-1">{{ getMaxUserDay
                        }}</strong>
                    <span>{{ $t("statisticPage.texts.total.usersToday") }}</span>
                    <strong class="text-2xl text-gray-700 mr-1">{{ getMaxUserOverall
                        }}</strong>
                    <span>{{ $t("statisticPage.texts.total.usersTotal") }}</span>
                </div>
            </div>
        </div>
    </div>
</template>